#include "ShaderConstants.fxh"
#include "util.fxh"

struct PS_Input
{
	float4 position : SV_Position;
	float2 uv : TEXCOORD_0_FB_MSAA;
	float3 pos : POS;
};

struct PS_Output
{
	float4 color : SV_Target;
};

/////////////////////////////////////////////////////////////////
///////////////////////// STOP! /////////////////////////////////
// Made by @bicubic7
// Don't steal anything!
// Don't use code without permit!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE) || (VERSION < 0xa000 /*D3D_FEATURE_LEVEL_10_0*/) 
	float4 diffuse = TEXTURE_0.Sample(TextureSampler0, PSInput.uv);
#else
	float4 diffuse = texture2D_AA(TEXTURE_0, TextureSampler0, PSInput.uv);
#endif

	float2 ftime = float2(pow(max(min(1.0-FOG_COLOR.r*1.5,1.),.0),1.2),pow(max(min(1.0-FOG_COLOR.r*1.2,1.),.0),.5));
	float size = lerp(lerp(1.8, 1.5,ftime.y), 0.9,ftime.x);
	float b = length(PSInput.pos.xz)*CURRENT_COLOR.r;

	float3 res = lerp(float3(1.0, 0.8, 0.0), float3(1.0, 0.6, 0.0) + FOG_COLOR.r,ftime.y);
		res = lerp(res, float3(1.0, 1.0, 1.0) *1.2 + FOG_COLOR.r + FOG_COLOR.g,ftime.x);
		res += max(0.1 / pow(length(PSInput.pos.xz*size) * 4.0, 8.0), 0.0) + abs(b * 7.0)/15.0;
		res += max(0.01 / pow(length(PSInput.pos.xz*size) * 1.0, 2.0 / 10.0), .0) + abs(b * 13.0)/20.0;
		res += (max(0.01 / pow(length(PSInput.pos.xz*size) * 20.0, 1.0 / 2.0), 0.0)*4.0)*4.0;
		res *= exp(0.5 - length(PSInput.pos.xz)) / lerp(7.0,9.,ftime.y);

diffuse.rgb = res*CURRENT_COLOR.rgb;
PSOutput.color = diffuse;
PSOutput.color.a = 1.0*(1.0-(1.-pow(FOG_CONTROL.y,10.)));

}
